// THIS MODIFICATION DATE:
// 25 Nov 1998     10:23 PM EST

#ifndef STACK_H
#define STACK_H

#include <fstream.h>

template <class type>
class item
{
  public:
    type t;
    item *last;
    item (type at)
    {
      t = at;
    }
};

template <class type>
class stack
{
  private:
    item<type> *lid;

  public:
    stack ()
    {
      lid = NULL;
    }

    stack *push (type at)
    {
      item<type> *poTemp = lid;
      lid = new item<type> (at);
      lid->last = poTemp;
      return this;
    }

    type top ()
    {
      return lid->t;
    }

    type pop ()
    {
      type tTemp = lid->t;
      item<type> *poTemp = lid->last;
      delete lid;
      lid = poTemp;
      return tTemp;
    }

    void output (char *asFile)
    {
      ofstream outfile;
      outfile.open (asFile, ios::out);
      stack<type> temp;

      while (more())
      {
        temp.push (pop());
      }

      outfile << "bottom  -->  lid\n";

      if (temp.more())
      {
        outfile << temp.pop();
      }

      while (temp.more())
      {
        outfile << ", " << temp.pop();
      }
    }

    bool more ()
    {
      return (lid != NULL);
    }

    void flush ()
    {
      while (more())
      {
        pop();
      }
    }
};

#endif